--
--
--
--
--
--

FillableFix = {};

function FillableFix.prerequisitesPresent(specializations)
	return SpecializationUtil.hasSpecialization(Fillable, specializations);
end;

function FillableFix:load(xmlFile)
print("function FillableFix:load(xmlFile)");
	self.setFillLevel = Utils.overwrittenFunction(self.setFillLevel, FillableFix.setFillLevel);
	self.lastFillLevel = 0;
	
	self.realLoading = {};
	self.realLoading.trailerEnd = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.realLoading#trailerEnd"));
	local x,y,z = getTranslation(self.realLoading.trailerEnd);
	self.realLoading.maxDistance = math.abs(z);
	self.realLoading.maxZ = z;	
end;

function FillableFix:delete()
end;

function FillableFix:mouseEvent(posX, posY, isDown, isUp, button)
end;

function FillableFix:keyEvent(unicode, sym, modifier, isDown)
end;

function FillableFix:update(dt)
end;

function FillableFix:updateTick(dt)
end;

function FillableFix:draw()
end;

function FillableFix:setFillLevel(superFunc, fillLevel, fillType, force)
--print("function FillableFix:setFillLevel("..tostring(superFunc)..", "..tostring(fillLevel)..", "..tostring(fillType)..", "..tostring(force));
--print("self.lastFillLevel="..tostring(self.lastFillLevel));
	
    if (force == nil or force == false) and not self:allowFillType(fillType, false) then
        return
    end;
	
    self.currentFillType = fillType;
    self.fillLevel = fillLevel;
    if self.fillLevel > self.capacity then
        self.fillLevel = self.capacity;
    end;
    if self.fillLevel <= 0 then
        self.fillLevel = 0;
        self.currentFillType = Fillable.FILLTYPE_UNKNOWN;
    end;


    if self.isClient then
        if self.currentFillPlane ~= nil then
            for _, node in ipairs(self.currentFillPlane.nodes) do
                setVisibility(node.node, false);
            end;
            self.currentFillPlane = nil;
        end;
        if self.fillPlanes ~= nil and self.defaultFillPlane ~= nil and fillType ~= Fillable.FILLTYPE_UNKNOWN then
            local fillTypeName = Fillable.fillTypeIntToName[fillType];
			local unload = false;
			if (self.tipState == Trailer.TIPSTATE_OPENING or self.tipState == Trailer.TIPSTATE_OPEN or self.tipState == Trailer.TIPSTATE_CLOSING ) or emptying then 
				if (self.currentFillType == Fillable.FILLTYPE_CHAFF) then
					fillTypeName = "chaff_unload";
					unload = true;
				elseif self.currentFillType == Fillable.FILLTYPE_GRASS_WINDROW then
					fillTypeName = "grass_windrow_unload";
					unload = true;
				end;
			end;
            local fillPlane = self.fillPlanes[fillTypeName];
            if fillPlane == nil then
                fillPlane = self.defaultFillPlane;
            end;
            local t = self.fillLevel/self.capacity;
            for _, node in ipairs(fillPlane.nodes) do
                local x,y,z, rx,ry,rz, sx,sy,sz = node.animCurve:get(t);

				--if self.tipState ~= Trailer.TIPSTATE_OPEN then
				--if self.fillLevel > self.lastFillLevel then
				if not unload then
					setTranslation(node.node, x, y, z);
				else
					local tz = (1-t)*self.realLoading.maxZ; --self.realLoading.maxDistance;
					setTranslation(node.node, x, y, tz);
				end;
                setRotation(node.node, rx, ry, rz);                
				setScale(node.node, sx, sy, sz);
                setVisibility(node.node, self.fillLevel > 0);
            end;
            self.currentFillPlane = fillPlane;
        end;
    end;
		
	self.lastFillLevel = self.fillLevel;
	
	--####
    if self.isClient then
        -- disable particle system if we switch the type or if the trailer is empty
        if fillLevel then --<= 0 and self.currentTipReferencePointIndex ~= nil) then
			for i,tipAnimation in pairs(self.tipAnimations) do
				--local tipAnimation = self.tipAnimations[self.currentTipReferencePointIndex];
				if tipAnimation ~= nil then
					for j,ps in pairs(tipAnimation.dischargeParticleSystems) do
						Utils.setEmittingState(ps, false);
					end
				end
			end;
        end
    end	
		
end;

